import type { RdComponentDefineProp, RdComponentDefineEvent } from '@elowcode/robotdev-design-types';
import { StmtParseConfig } from './stmt';
import { DesignerCtx } from './stmt/index.d';
export declare const getConstructorByString: (str: string) => BooleanConstructor | ObjectConstructor | ArrayConstructor | StringConstructor | NumberConstructor | undefined;
export declare const getDefault: (str: string, def: any) => any;
interface RegConfig extends StmtParseConfig {
    tag: string;
    defineProps?: RdComponentDefineProp[];
    defineEvents?: RdComponentDefineEvent[];
}
export declare const registerComponent: (renderConfig: RegConfig, designerCtx: DesignerCtx, self: any) => import("vue").DefineComponent<{}, () => any, {}, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, any, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{}>>, {}> | undefined;
/**
 * 获取某个注册的组件
 * @param {object} self 组件实例
 * @param {string} tagName 组件名
 * @return {null || object}
 */
export declare const getComponents: (tagName?: string) => any;
/**
 * 获取某个注册的组件
 * @param {object} self 组件实例
 * @param {string} tagName 组件名
 * @return {null || object}
 */
export declare const getComponent: (tagName?: string) => any;
/**
 * 获取某个组件的schema
 * @param {string} tagName 组件名
 * @return {null || object}
 */
export declare const getOptions: (tagName?: string) => any;
export declare const getOptionsProp: (cmpt: any) => any[];
export declare const nodeToFlintData: (nodes?: any[], schema?: any[]) => any[];
export declare const dataToProps: (nodes: any[], props?: {
    [x: string]: any;
}) => {
    [x: string]: any;
};
export declare const slotToNodes: (slotOption: any) => any[];
export declare const dataToNodes: (data: any) => Array<any>;
export declare const propsToData: (props: {
    [x: string]: any;
} | undefined, nodes: any[]) => any[];
export {};
//# sourceMappingURL=register.d.ts.map