import type { CallVoid } from './stmt'

type HookId = string | number
type HookType = string
type HookLabel = string
export interface HookOther {
  '//': HookLabel
}

export type Hook = [HookId, HookType, CallVoid, HookOther?]
export type Hooks = Hook[]
export interface HookApi {
  i: () => HookId
  t: () => HookType
  l: () => HookLabel | undefined
  v: () => CallVoid
}

export type HookGetApi = (hookType: HookType) => HookApi[]

export type HookAddValue = {
  i: HookId
  t: HookType
  l: HookLabel
  v: CallVoid
}
export type HookSetValue = {
  i: HookId
  t: HookType
  l: HookLabel
  v: CallVoid
}

export interface HooksApi {
  export: () => Hook[]
  get: (hookId: HookId) => undefined | HookApi
  getAll: HookGetApi
  list: () => HookApi[]
  reload: (hooks: Hook[]) => void
  set: (hookId: HookId, value: HookSetValue) => undefined | HookApi
  add: (value: HookAddValue) => HookApi
  removeOne: (hookId: HookId) => void
  remove: (hookType: HookType) => void
}
