import type { NodeId } from './node'
import type { Call, CallVoid } from './stmt'

type NodeOnName = string

// 数据库中每一行的数据结构
export type NodeOnBind = [NodeId, NodeOnName, CallVoid | null]
export interface NodeOnBindOneApi {
  i: () => NodeId
  n: () => NodeOnName
  c: () => CallVoid | null
}

export type NodeOnBindGetAllApi = (nodeId: NodeId) => NodeOnBindOneApi[]

export type NodeOnBindAddValue = {
  i: NodeId
  n: NodeOnName
  c?: CallVoid
}
export type NodeOnBindSetValue = {
  c: CallVoid
}

export interface NodeOnBindApi {
  toDbs: (nodeId?: NodeId) => NodeOnBind[]
  get: (nodeId: NodeId, name: NodeOnName) => undefined | NodeOnBindOneApi
  getAll: NodeOnBindGetAllApi
  set: (nodeId: NodeId, name: NodeOnName, value: NodeOnBindSetValue) => undefined | NodeOnBindOneApi
  add: (value: NodeOnBindAddValue) => NodeOnBindOneApi
  remove: (nodeId: NodeId, name?: NodeOnName) => void
}
