import type { NodeId } from './node'
import type { Call } from './stmt'

export type NodePropsName = string

// 数据库中每一行的数据结构
export type NodePropsBind = [NodeId, NodePropsName, Call]

export interface NodePropsBindOneApi {
  i: () => NodeId
  n: () => NodePropsName
  c: () => Call
}

export type NodePropsBindGetAllApi = (nodeId: NodeId) => NodePropsBindOneApi[]

export type NodePropsBindAddValue = {
  i: NodeId
  n: NodePropsName
  c: Call
}
export type NodePropsBindSetValue = {
  c: Call
}

export interface NodePropsBindApi {
  toDbs: (nodeId?: NodeId) => NodePropsBind[]
  get: (nodeId: NodeId, name: NodePropsName) => NodePropsBindOneApi | undefined
  getAll: NodePropsBindGetAllApi
  set: (nodeId: NodeId, name: NodePropsName, value: NodePropsBindSetValue) => undefined | NodePropsBindOneApi
  add: (value: NodePropsBindAddValue) => NodePropsBindOneApi
  remove: (nodeId: NodeId, name?: NodePropsName) => void
}
