export type SnapshotAction = string
export type SnapshotParam = any
export type SnapshotData = any
export type SnapshotTimestamp = number
export type Snapshot = [SnapshotAction, SnapshotParam, SnapshotData, SnapshotTimestamp]

export interface SnapshotApi {
  list: () => Snapshot
  index: () => number
  isFirst: () => boolean
  isLast: () => boolean
  backward: () => void
  forward: () => void
  add: (action: SnapshotAction, param: SnapshotParam, data: SnapshotData, debounceTime?: number) => void
  undo: () => {
    last: undefined | [SnapshotAction, SnapshotParam, SnapshotData]
    target: undefined | [SnapshotAction, SnapshotParam, SnapshotData]
  }
  redo: () => {
    next: undefined | [SnapshotAction, SnapshotParam, SnapshotData]
  }
  search: (action: SnapshotAction, param: SnapshotParam) => any
}
